﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using DigitaAdvantage.ClickOnce;
using System.Diagnostics;

namespace DigitaAdvantage.ClickOnce.Forms
{
    internal partial class CheckPane : MainPane
    {
        private Form parentMainForm;

        public CheckPane(Form parentForm, string appProductName, string serverName, string supportUrl)
        {
            parentMainForm = parentForm;

            Assembly asm = DeploymentUtil.GetSystemDeploymentAssembly();
            Stream streamSetup = asm.GetManifestResourceStream("setup.bmp");
            Stream streamAppIco = asm.GetManifestResourceStream("defaultappicon.ico");
            
            InitializeComponent();

            this.SuspendLayout();
            this.labelHeader.Font = new Font(this.labelHeader.Font, this.labelHeader.Font.Style | FontStyle.Bold);
            this.linkLabelAppName.Font = new Font(this.linkLabelAppName.Font, this.linkLabelAppName.Font.Style | FontStyle.Bold);
            this.labelServerName.Font = new Font(this.labelServerName.Font, this.labelServerName.Font.Style | FontStyle.Bold);
            this.pictureBoxTop.Image = new Bitmap(streamSetup);
            this.labelSubHeader.Text = String.Format("新しいバージョン {0} が利用可能です。今すぐダウンロードしますか?", appProductName);
            this.linkLabelAppName.Text = appProductName;
            this.linkLabelAppName.Links.Clear();
            if (DeploymentUtil.IsValidSupportUrl(supportUrl))
            {
                this.linkLabelAppName.Links.Add(0, appProductName.Length, supportUrl);
            }
            this.labelServerName.Text = serverName;
            this.ResumeLayout(false);

            parentMainForm.SuspendLayout();
            parentMainForm.Text = "利用可能な更新があります";
            parentMainForm.MinimizeBox = false;
            parentMainForm.MaximizeBox = false;
            parentMainForm.ControlBox = true;
            parentMainForm.ResumeLayout(false);
            parentMainForm.PerformLayout();

            if (Form.ActiveForm != parentMainForm)
            {
                parentMainForm.Activate();
            }
        }

        private void CheckPane_Load(object sender, EventArgs e)
        {
            parentMainForm.ActiveControl = this.buttonOK;
        }

        private void buttonSkip_Click(object sender, EventArgs e)
        {
            base.IsCanceled = true;
        }

        private void linkLabelAppName_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            this.linkLabelAppName.LinkVisited = true;
            string url = e.Link.LinkData.ToString();
            try
            {
                Process.Start(url);
            }
            catch
            {
            }
        }

        public override bool OnClosing()
        {
            bool ret = base.OnClosing();
            base.IsCanceled = true;
            return ret;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            base.IsProceeded = true;
        }
    }
}
