﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DigitaAdvantage.ClickOnce.Forms
{
    internal partial class MainPane : UserControl
    {
        private bool proceeded;
        private bool canceled;
        private bool error;

        public MainPane()
        {
            InitializeComponent();

            proceeded = false;
            canceled = false;
            error = false;
        }

        public virtual bool OnClosing()
        {
            return false;
        }

        public bool IsCanceled
        {
            get { return canceled; }
            set { canceled = value; }
        }

        public bool IsProceeded
        {
            get { return proceeded; }
            set { proceeded = value; }
        }

        public bool IsError
        {
            get { return error; }
            set { error = value; }
        }

        public virtual string ProgressMessageText
        {
            set { }
        }

        public virtual int ProgressPercentage
        {
            set { }
        }
    }
}
